from axelrod.action import Action
from axelrod.player import Player
llIIllIllIlIlIllIllI, IIlIlllIIIlIIIIIl = Action.C, Action.D
class llIlIllIlllIl(Player):
    IIlIlIlII = "strategy"
    llIlllllllIIII = {
        "memory_depth": float("inf"),  
        "stochastic": False,
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def __init__(lIllIIIIIIIIlIl) -> None:
        super().__init__()
        lIllIIIIIIIIlIl.IllIIlIIIllllIIlIll = 1
        lIllIIIIIIIIlIl.lIIlIlllIl = False
        lIllIIIIIIIIlIl.llllllIIlIIlIII = 1
    def lIIIlllIIlllIIlI(lIllIIIIIIIIlIl, IIIIllIlIl: Player) -> Action:
        if lIllIIIIIIIIlIl.llllllIIlIIlIII >= lIllIIIIIIIIlIl.IllIIlIIIllllIIlIll:
            lIllIIIIIIIIlIl.llllllIIlIIlIII = 0
            lIllIIIIIIIIlIl.lIIlIlllIl = False
        if lIllIIIIIIIIlIl.lIIlIlllIl:
            lIllIIIIIIIIlIl.llllllIIlIIlIII += 1
            return IIlIlllIIIlIIIIIl
        elif IIlIlllIIIlIIIIIl in IIIIllIlIl.history[-1:]:
            lIllIIIIIIIIlIl.IllIIlIIIllllIIlIll = (IIIIllIlIl.defections * 20) // len(
                IIIIllIlIl.history
            )
            lIllIIIIIIIIlIl.lIIlIlllIl = True
            return IIlIlllIIIlIIIIIl
        return llIIllIllIlIlIllIllI